<?php

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

class MDHQCRelayNRSettings
{
    public function __construct()
    {
        add_action( 'init', array( &$this, 'wc_nrorderemail_include_functions' ), 1 );
        add_action( 'init', array( &$this, 'wc_nrorderemail_site_functions' ), 1 );
        add_action( 'woocommerce_init', array( &$this, 'wc_nrorderemail_loaded' ) );
        if ( is_admin() ) {
            $this->wc_nrorderemail_admin_includes();
        }
    }

    public function wc_nrorderemail_include_functions() {
        include_once( 'includes/nr_orderemail_functions.php' );
        include_once( 'mdhq-webhooks-delay.php' );
    }
    public function wc_nrorderemail_site_functions() {
        include_once( 'includes/site/site_functions.php' );
        include_once( 'includes/admin/admin_functions.php' );
        include_once( 'includes/admin/auto_login_settings.php' );
    }
    public function wc_nrorderemail_admin_includes() {
        include_once( 'includes/site/site_functions.php' );
        include_once( 'includes/admin/admin_functions.php' );
        include_once( 'includes/admin/auto_login_settings.php' );
    }
    public function wc_nrorderemail_loaded() {
        global $woocommerce;
        include_once( 'includes/admin/admin_functions.php' );
        add_action('admin_menu', 'nr_register_orderemail_menu_page');
        add_action( 'init', 'nr_csv_download');
        add_action( 'init', 'nr_user_login');
//        add_action( 'woocommerce_init', 'nr_user_login2');
        add_action( 'woocommerce_before_my_account', 'nr_woocommerce_before_my_account', 1);
        add_filter( 'insert_user_meta', 'nr_insert_user_meta', 10, 3 );
        add_action( 'show_user_profile', 'nr_user_auto_link' );
        add_action( 'edit_user_profile', 'nr_user_auto_link' );
    }
}
