<?php

if(!function_exists("assign_wc_membership_menu")){
    
function assign_wc_membership_menu()
{
    add_submenu_page(
        'mdhqc-relay',
        'Woo Auto Membership',
        'Woo Auto Membership',
        'manage_options',
        'assign-woo-membership-settings',
        'assign_wc_membership_settings_page'
    );

    add_submenu_page(
        'mdhqc-relay',
        'New Member Email',
        'New Member Email',
        'manage_options',
        'relay-new-mem-email',
        'new_mem_view'
    );
}

}
function new_mem_view()
{
    if (isset($_POST['mdhqd_mem'])) {
        $arr = empty($_POST['mdhqd_mem']) ? [] : $_POST['mdhqd_mem'];
        foreach ($arr as &$row) {
            $row['message'] = stripslashes($row['message']);
        }
        update_option('mdhqd_membership_mails', json_encode($arr));
    }

    $arr = get_option('mdhqd_membership_mails', '');
    $arr = empty($arr) ? [] : json_decode($arr, true);

    $totalNumber = count($arr);
    wp_enqueue_style( 'orderemail_bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css' );
//    wp_enqueue_script( 'mem_tinymce', 'https://cdn.tiny.cloud/1/no-api-key/tinymce/5/tinymce.min.js' );
    wp_enqueue_editor();
    wp_enqueue_media();
    ?>
    <div class="container">
        <form action="" method="post">
            <input type="hidden" id="num_of_codes" value="<?= $totalNumber ?>">
            <div id="all_divs">
                <?php
                    if (!empty($arr)) {
                        $num = 1;
                        foreach ($arr as $row) {
                ?>
                        <div id="main_div_<?php echo $num;?>" class="card" style="max-width: 100%">
                            <div class="float-right"><button data-id="<?php echo $num;?>" class="btn btn-primary remove-divs">Remove</button> </div>
                            <div class="form-group"> <label for="">Access Code *</label> <input type="text" value="<?php echo $row['code'];?>" class="form-control" placeholder="Default - If you want to send default if no template is set." id="" name="mdhqd_mem[<?php echo $num; ?>][code]" required=""> </div>
                            <div class="form-group"><label for="">Subject *</label> <input type="text" value="<?php echo $row['subject'];?>" class="form-control" placeholder="" id="" name="mdhqd_mem[<?php echo $num; ?>][subject]" required=""> </div>
                            <div class="form-group"><label for="">Message *</label>
                                <div>You can use the following tags:<br><br><b>[username]</b> - Username<br><b>[email]</b> - E-mail<br> <b>[first_name]</b> - First Name<br><b>[last_name]</b> - Last Name<br><b>[access_code]</b> - Access code<br> <b>[provider]</b> - Provider<br> <b>[1click_login]</b> - 1-Click Login<br> </div>
                            <?php
                                $settings = array(
                                        'textarea_name' => 'mdhqd_mem['. $num .'][message]',
//                                        'wpautop' => true,
                                        'plugins' => 'charmap colorpicker compat3x directionality fullscreen hr image lists media paste tabfocus textcolor wordpress wpautoresize wpdialogs wpeditimage wpemoji wpgallery wplink wptextpattern wpview',
                                        'toolbar1' => 'formatselect bold italic | bullist numlist | blockquote | alignleft aligncenter alignright | link unlink | wp_more | spellchecker'
                                );
                                wp_editor($row['message'], 'editor_' . $num, $settings);
                            ?>
                            </div>
                        </div>
                <?php
                            $num++;
                        }
                    }
                ?>
            </div>

            <br>
            <button type="button" id="add_mem_email" class="btn btn-primary">Add Notification</button>
            <br>
            <br>
            <button type="submit" id="" class="btn btn-primary">Submit</button>
        </form>
    </div>
    <script>
        var $ = jQuery;
        $(document).ready(function () {
            var settings = {
                mediaButtons: true,
                tinymce: {
                    wpautop: true,
                    plugins : 'charmap colorpicker compat3x directionality fullscreen hr image lists media paste tabfocus textcolor wordpress wpautoresize wpdialogs wpeditimage wpemoji wpgallery wplink wptextpattern wpview',
                    toolbar1: 'formatselect bold italic | bullist numlist | blockquote | alignleft aligncenter alignright | link unlink | wp_more | spellchecker'
                },
                quicktags: true
            };
            var counter = $('#num_of_codes').val();
            $('#add_mem_email').on('click', function (e) {
                e.preventDefault();
                counter++;
                var html = '<div id="main_div_' + counter + '" class="card" style="max-width: 100%"> <div class="float-right"><button data-id="'+counter+'" class="btn btn-primary remove-divs">Remove</button> </div> <div class="form-group"> <label for="">Access Code *</label> <input type="text" value="" class="form-control" placeholder="Default - If you want to send default if no template is set." id="" name="mdhqd_mem['+counter+'][code]" required> </div><div class="form-group"><label for="">Subject *</label> <input type="text" value="" class="form-control" placeholder="" id="" name="mdhqd_mem['+counter+'][subject]" required> </div> <div class="form-group"><label for="">Message *</label><div>You can use the following tags:<br><br><b>[username]</b> - Username<br><b>[email]</b> - E-mail<br> <b>[first_name]</b> - First Name<br><b>[last_name]</b> - Last Name<br><b>[access_code]</b> - Access code<br> <b>[provider]</b> - Provider<br> <b>[1click_login]</b> - 1-Click Login<br> </div> <textarea rows="20" cols="49" id="editor_'+counter+'" name="mdhqd_mem['+counter+'][message]"  class="wp-editor tinymc-editor"> </textarea> </div> </div>';
                $('#all_divs').append(html);
                wp.editor.initialize('editor_' +counter, settings);
            });

            $(document).on('click', '.remove-divs', function (e) {
                e.preventDefault();
                let idOfDiv = 'main_div_' + $(this).attr('data-id');
                $('#' + idOfDiv).remove();
            })
        });
    </script>
    <?php
}

function assign_wc_membership_settings_page()
{
    $plans = wc_memberships_get_membership_plans();
    $plansList = [];
    foreach ($plans as $plan){
        $individualPlan = [
            'id' => $plan->id,
            'name' => $plan->name,
        ];
        array_push($plansList,$individualPlan);
    }
    ?>
	<style>
		:root {
    --switches-bg-color: #2271b1;
    --switches-label-color: white ;
    --switch-bg-color: white;
    --switch-text-color: #2271b1 ;
}
/* container for all of the switch elements 
    - adjust "width" to fit the content accordingly 
*/
.switches-container {
    width: 8rem;
    position: relative;
    display: flex;
    padding: 0;
    position: relative;
    background: var(--switches-bg-color);
    line-height: 2rem;
    border-radius:2rem;
}

/* input (radio) for toggling. hidden - use labels for clicking on */
.switches-container input {
    visibility: hidden;
    position: absolute;
    top: 0;
}

/* labels for the input (radio) boxes - something to click on */
.switches-container label {
    width: 50%;
    padding: 0;
    margin: 0;
    text-align: center;
    cursor: pointer;
    color: var(--switches-label-color);
}

/* switch highlighters wrapper (sliding left / right) 
    - need wrapper to enable the even margins around the highlight box
*/
.switch-wrapper {
    position: absolute;
    top: 0;
    bottom: 0;
    width: 50%;
    padding: 0.15rem;
    z-index: 3;
    transition: transform .5s cubic-bezier(.77, 0, .175, 1);
    /* transition: transform 1s; */
}

/* switch box highlighter */
.switch {
    border-radius: 3rem;
    background: var(--switch-bg-color);
    height: 100%;
}

/* switch box labels
    - default setup
    - toggle afterwards based on radio:checked status 
*/
.switch div {
    width: 100%;
    text-align: center;
    opacity: 0;
    display: block;
    color: var(--switch-text-color) ;
    transition: opacity .2s cubic-bezier(.77, 0, .175, 1) .125s;
    will-change: opacity;
    position: absolute;
    top: 0;
    left: 0;
}

/* slide the switch box from right to left */
.switches-container input:nth-of-type(1):checked~.switch-wrapper {
    transform: translateX(0%);
}

/* slide the switch box from left to right */
.switches-container input:nth-of-type(2):checked~.switch-wrapper {
    transform: translateX(100%);
}

/* toggle the switch box labels - first checkbox:checked - show first switch div */
.switches-container input:nth-of-type(1):checked~.switch-wrapper .switch div:nth-of-type(1) {
    opacity: 1;
}

/* toggle the switch box labels - second checkbox:checked - show second switch div */
.switches-container input:nth-of-type(2):checked~.switch-wrapper .switch div:nth-of-type(2) {
    opacity: 1;
}
		.form-table.without-code{
			width:70%;
		}
</style>
    <div class="wrap">
	
        <h2>Case Manager</h2>
		
        <?php
        $optionName = 'as_wc_membership_options';
        if(!get_option($optionName)) {
            $option = [];
            add_option($optionName,$option);
        }
	
        if(!empty($_POST))
        {
            $options = []; //New Variable for storing new options
            if(isset($_POST['number_of_cases'])){
                $casesRemaining = $_POST['number_of_cases'];
                $i = 0;
                while($casesRemaining > 0 && $i <= 50){
                    $i++;
                    if(isset($_POST['case_option_'.$i]) && isset($_POST['case_plan_'.$i])){
                        $case = [
                            'caseOption' => $_POST['case_option_'.$i],
                            'casePlan' => $_POST['case_plan_'.$i],
                            'caseAccess' => $_POST['case_access_'.$i],
                        ];
                        array_push($options,$case);
                        $casesRemaining--;
                    }
                }
            }
			
            update_option($optionName,$options);
			//Without code option
			if(isset($_POST['case_option_wc_1'])){
				update_option('case_option_wc_1', $_POST['case_option_wc_1']);
			}
			if(isset($_POST['case_option_wc_2'])){
				update_option('case_option_wc_2', $_POST['case_option_wc_2']);
			}
			if(isset($_POST['case_plan_wc_1'])){
				update_option('case_plan_wc_1', $_POST['case_plan_wc_1']);
			}
			if(isset($_POST['case_plan_wc_2'])){
				update_option('case_plan_wc_2', $_POST['case_plan_wc_2']);
			}
			update_option('case_access_code_wc', $_POST['accessCode']);
        }
        $options = get_option($optionName);
        ?>
        <form method="post">
			<label>Access Code</label>
		<div class="switches-container">		
			<input type="radio" id="enableCode" name="accessCode" value="enable" <?php echo !get_option('case_access_code_wc') || get_option('case_access_code_wc') == 'enable' ? 'checked="checked"': ''; ?> />
			<input type="radio" id="disableCode" name="accessCode" value="disable" <?php echo get_option('case_access_code_wc') == 'disable' ? 'checked="checked"': ''; ?> />
			<label for="enableCode">Enable</label>
			<label for="disableCode">Disable</label>
			<div class="switch-wrapper">
			  <div class="switch">
				<div>Enable</div>
				<div>Disable</div>
			  </div>
			</div>
			</div>
            <?php
            settings_fields( 'woo-membership-settings' );
            do_settings_sections( 'woo-membership-settings' );
            ?>
            <input type="hidden" name="number_of_cases" id="number_of_cases" value="<?php echo count($options); ?>">
            <table class="form-table with-code" <?php echo get_option('case_access_code_wc') == 'disable' ? 'style="display:none;"': ''; ?> >
                <tbody id="case-table">
                <?php
                $plans = $plansList;
                $i=0;
                foreach ($options as $option)
                {
                    $i++;
                    $planOptions = '<option value="">Select Plan</option>';
                    foreach ($plans as $plan){
                        $selected = '';
                        if($option['casePlan'] == $plan['id'])
                        {
                            $selected = 'selected';
                        }
                        $planOptions.='<option value="'.$plan['id'].'" '.$selected.'>'.$plan['name'].'</option>';
                    }
                    ?>
                    <tr class="case-row">
                        <th scope="col">
                            <label for="case_option_<?php echo $i; ?>">Option Name</label>
                        </th>
                        <td>
                            <input name="case_option_<?php echo $i; ?>" type="text" id="case_option_<?php echo $i; ?>" value="<?php if(isset($option['caseOption']) && !empty($option['caseOption'])){ echo $option['caseOption']; }; ?>" class="regular-text code">
                        </td>
                        <th scope="col">
                            <label for="case_plan_<?php echo $i; ?>">Plan</label>
                        </th>
                        <td>
                            <select name="case_plan_<?php echo $i; ?>" id="case_plan_<?php echo $i; ?>">
                                <?php echo $planOptions; ?>
                            </select>
                        </td>
                        <th scope="col">
                            <label for="case_access_<?php echo $i; ?>">Access Code</label>
                        </th>
                        <td>
                            <input name="case_access_<?php echo $i; ?>" type="text" id="case_access_<?php echo $i; ?>" value="<?php if(isset($option['caseAccess']) && !empty($option['caseAccess'])){ echo $option['caseAccess']; }; ?>" class="regular-text code">
                        </td>
                        <td>
                            <input type="submit" onclick="event.preventDefault();deleteCase(this);" value="&times;" class="button">
                        </td>
                    </tr>

                    <?php
                }
                ?>
                </tbody>
            </table>
			<?php 
			//PlanOptions without Code
			$planOptionsWC1 = '<option value="">Select Plan</option>';
                    foreach ($plans as $plan){
                        $selected = '';
                        if(get_option('case_plan_wc_1') == $plan['id'])
                        {
                            $selected = 'selected';
                        }
                        $planOptionsWC1.='<option value="'.$plan['id'].'" '.$selected.'>'.$plan['name'].'</option>';
                    }
			$planOptionsWC2 = '<option value="">Select Plan</option>';
                    foreach ($plans as $plan){
                        $selected = '';
                        if(get_option('case_plan_wc_2') == $plan['id'])
                        {
                            $selected = 'selected';
                        }
                        $planOptionsWC2.='<option value="'.$plan['id'].'" '.$selected.'>'.$plan['name'].'</option>';
                    }
			?>
			<table class="form-table without-code" width="70%" <?php echo !get_option('case_access_code_wc') || get_option('case_access_code_wc') == 'enable' ? 'style="display:none;"': ''; ?>>
                <tbody id="case-table-without-code">
                    <tr class="case-row" style="display:none;">
                        <th scope="col">
                            <label for="case_option_wc_1">Option Name (Cerbo)</label>
                        </th>
                        <td>
                            <input name="case_option_wc_1" type="text" id="case_option_wc_1" value="<?php echo get_option('case_option_wc_1'); ?>" class="regular-text code">
                        </td>
                        <th scope="col">
                            <label for="case_plan_wc_1">Plan</label>
                        </th>
                        <td>
                            <select name="case_plan_wc_1" id="case_plan_wc_1">
                                <?php echo $planOptionsWC1; ?>
                            </select>
                        </td>
						<td>&nbsp;</td>
                    </tr>
					<tr class="case-row">
                        <th scope="col">
                            <label for="case_option_wc_2">Option Name (Shop)</label>
                        </th>
                        <td>
                            <input name="case_option_wc_2" type="text" id="case_option_wc_2" value="<?php echo get_option('case_option_wc_2'); ?>" class="regular-text code">
                        </td>
                        <th scope="col">
                            <label for="case_plan_wc_2">Plan</label>
                        </th>
                        <td>
                            <select name="case_plan_wc_2" id="case_plan_wc_2">
                                <?php echo $planOptionsWC2; ?>
                            </select>
                        </td>
						<td>&nbsp;</td>
                    </tr>
                </tbody>
            </table>
            <!-- remove some meta and generators from the <head> -->
            <?php submit_button( 'Add Case', 'secondary case-btn', 'submit', FALSE,[
                'onclick' => 'event.preventDefault();addCase();'
            ]);; ?>
            <?php submit_button('Save all changes', 'primary','submit', FALSE); ?>
        </form>
        <script>
            <?php
            $planOptions='<option value="">Select Plan</option>';
            foreach ($plans as $plan){
                $planOptions.='<option value="'.$plan['id'].'" >'.$plan['name'].'</option>';
            }
            ?>
            var $ = jQuery;
            function addCase(){
                var counter = getId();
                counter++;
                $('#number_of_cases').val(parseInt($('#number_of_cases').val())+1);
                $('#case-table').append('<tr class="case-row"><th scope="col"><label for="case_option_'+counter+'">Option Name</label></th><td><input name="case_option_'+counter+'" type="text" id="case_option_'+counter+'" value="" class="regular-text code"></td><th scope="col"><label for="case_plan_'+counter+'">Plan</label></th><td><select name="case_plan_'+counter+'" id="case_plan_'+counter+'"><?php echo $planOptions; ?></select></td><th scope="col"><label for="case_access_<?php echo $i; ?>">Access Code</label></th><td><input name="case_access_'+counter+'" type="text" id="case_access_'+counter+'" class="regular-text code"></td><td><input type="submit" onclick="event.preventDefault();deleteCase(this);" value="&times;" class="button"></td></tr>');
            }

            function getId(){
                var length = $('.case-row').length;
                var countAsPerInput = $('#number_of_cases').val();
                if(parseInt(length) == parseInt(countAsPerInput)){
                    return parseInt(length);
                }
                else
                {
                    return parseInt(countAsPerInput);
                }
            }
            function deleteCase(element) {
                $(element).closest('.case-row').remove();
                $('#number_of_cases').val(parseInt($('#number_of_cases').val())-1);
            }
			$('document').ready(function(){
				<?php if(get_option('case_access_code_wc') == 'disable'){?>
				$('.case-btn').hide();
				<?php }?>
				$('#enableCode').click(function(){
					$('.form-table.with-code').show();
					$('.case-btn').show();
					$('.form-table.without-code').hide();
					
				});
				$('#disableCode').click(function(){
					$('.form-table.without-code').show();
					$('.case-btn').hide();
					$('.form-table.with-code').hide();
				});
				
			});
        </script>
    </div>
    <?php
    //include_once('admin\woo_assign_membership_setttings.php' );
}

function assign_wc_options_form() {
    wp_enqueue_script('assign_wc_options_script',MDHQC_PLUGIN_PATH . "resources/assign_wc_options_script.js",array('jquery'),'2.0');
    wp_enqueue_style('assign_wc_options_style',MDHQC_PLUGIN_PATH . "resources/assign_wc_options.css");
    wp_localize_script( 'assign_wc_options_script', 'assign_wc_options', array(
        'ajax_urls' => admin_url( 'admin-ajax.php' ),
    ));
    $fields = [
        [ "name" => 'username', "type" => 'text', 'required' => true,'label' => 'Username' ],
        [ 'name' => 'email', 'type' => 'email' ,'required' => true,'label' => 'Email'],
        [ 'name' => 'first_name', 'type' => 'text' ,'required' => false,'label' => 'First Name' ],
        [ 'name' => 'last_name', 'type' => 'text' ,'required' => false,'label'=>'Last Name' ],
        [ 'name' => 'password', 'type' => 'password' ,'required' => true,'label' => 'Account Password' ],
        [ 'name' => 'case_option', 'type' => 'select' ,'required' => true,'label' => 'Select your provider','options'=> assign_wc_options() ],
        [ 'name' => 'access_code', 'type' => 'text' ,'required' => true,'label' => 'Provider Access Code' ],
    ];
    $form = '<form method="post" id="assign_wc_options_register_form" onsubmit="event.preventDefault();submit_assign_wc_options_register_form()">';
    foreach($fields as $field){
		if(get_option('case_access_code_wc') == 'disable' && ($field['name'] == 'access_code' || $field['name'] == 'first_name' || $field['name'] == 'last_name')) continue; 
        $args = '';
        if(isset($field['args'])){
            foreach ($field['args'] as $key => $value){
                $args.=$key."=".$value;
            }
        }
        if(isset($field['required']) && $field['required']){
            $args.='data-required="yes"';
        }
        if($field['type'] == 'text' || $field['type'] == 'email' || $field['type'] == 'password' ){
            $form.='<div class="input-container"><label>'.$field['label'].'</label><input class="assign_wc_options" type="'.$field['type'].'" name="'.$field['name'].'" '.$args.'/></div>';
        }
        else if($field['type'] == 'select'){
        }
    }
    $form.= '<div class="input-button"><input type="submit" value="Register" id="assign_wc_options_submit_button" onclick="event.preventDefault();submit_assign_wc_options_register_form()" ></div>
        <div class="alerts" id="assign_wc_options_message"></div>
</form>';
    return $form;
}

function assign_wc_options(){
    $options = get_option('as_wc_membership_options');
    $selectOptions = [];
    foreach ($options as $option){
        $selectOption = [
            'label' => $option['caseOption'],
            'value' => $option['caseOption'],
        ];
        array_push($selectOptions,$selectOption);
    }
    return $selectOptions;
}

function caseDetails($caseOption){
    $options = get_option('as_wc_membership_options');
    foreach ($options as $option){
        if($option['caseOption'] == $caseOption){
            return $option;
        }
    }
    return false;
}

function caseDetailsByCode( $caseAccess ) {
	$options = get_option('as_wc_membership_options');
	foreach ( $options as $option ) {
		if ( $option['caseAccess'] == $caseAccess ) {
			return $option;
		}
	}
	return false;
}

function assign_wc_options_register_user(){
    $username = $_POST['username'];
    $email = $_POST['email'];
    $password = $_POST['password'];
    if(username_exists($username)){
        echo json_encode([ 'success' => 'false', 'message' => 'Username already taken. Please try again with different username.' ]);
    }else if(email_exists($email)){
        echo json_encode([ 'success' => 'false', 'message' => 'Email already registered. Please login <a href="'.wp_login_url().'">here</a>' ]);
    }elseif(get_option('case_access_code_wc') == 'disable'){
		    $case_option = get_option('case_option_wc_2');
            $plan_id = get_option('case_plan_wc_2');
            $userDetails = [
                'user_login' => $username,
                'user_pass' => $password,
                'user_email' => $email
            ];
            $userId = wp_insert_user($userDetails);
            $args = array(
                'plan_id'	=> $plan_id,
                'user_id'	=> $userId,
            );
            wc_memberships_create_user_membership( $args );
			$user = get_user_by( 'id',$userId);

            if( $user ) {
                wp_set_current_user( $userId, $user->user_login );
                wp_set_auth_cookie( $userId );

                do_action( 'wp_login', $user->user_login, $user );
            }
            echo json_encode([ 'success' => 'true','loginUrl'=>get_site_url().'/shop/', 'message' => 'You have been successfully registered. You are being logged in now.']);
	}else{
		$first_name = $_POST['first_name'];
   		$last_name = $_POST['last_name'];

		$access_code = $_POST['access_code'];
		$caseDetails = caseDetailsByCode( $access_code );
	if ( $caseDetails ) {
		$case_option = $caseDetails['caseOption'];
            $plan_id = $caseDetails['casePlan'];
            $userDetails = [
                'user_login' => $username,
                'first_name' => $first_name,
                'last_name' => $last_name,
                'user_pass' => $password,
                'user_email' => $email
            ];
            $userId = wp_insert_user($userDetails);
            $args = array(
                'plan_id'	=> $plan_id,
                'user_id'	=> $userId,
            );
            wc_memberships_create_user_membership( $args );
			$user = get_user_by( 'id',$userId);

            if( $user ) {
                wp_set_current_user( $userId, $user->user_login );
                wp_set_auth_cookie( $userId );

                do_action( 'wp_login', $user->user_login, $user );
            }
            echo json_encode([ 'success' => 'true','loginUrl'=> get_site_url().'/shop/', 'message' => 'You have been successfully registered. You are being logged in now.']);
        }else{
            echo json_encode([ 'success' => 'false', 'message' => 'Invalid Access Code! Please verify your access code and try again.' ]);
        }

    }
    wp_die();
}