<?php
namespace BBWP\InspiredHealthMed;

// exit if file is called directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class PluginDefault extends Plugin{

	use \BBWP\InspiredHealthMedGeneral\Traits\Singleton;

	/******************************************/
	/***** class constructor **********/
	/******************************************/
  public function __construct(){
    
    //localization hook
    add_action( 'plugins_loaded', array($this, 'plugins_loaded') );
    

		if(is_admin()){

      //add settings page link to plugin activation page.
      //add_filter( 'plugin_action_links_'.plugin_basename(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE), array($this, 'plugin_action_links') );

      // Plugin activation hook
      //register_activation_hook(plugin_basename(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE), array($this, 'PluginActivation'));

      // plugin deactivation hook
      //register_deactivation_hook(plugin_basename(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE), array($this, 'PluginDeactivation'));


      //\BBWP\InspiredHealthMed\Admin\PageSettings::instance();

      // add javascript and css to wp-admin dashboard.
      // add_action( 'admin_enqueue_scripts', array($this, 'wp_admin_style_scripts') );

		}else{
      // add javascript and css to front end.
      add_action( 'wp_enqueue_scripts', array($this, 'wp_admin_style_scripts'), (PHP_INT_MAX + 1) );
    }

		add_action( 'init', [ $this, 'init' ] );

  }// construct function end here

  /******************************************/
	/***** add settings page link in plugin activation screen.**********/
	/******************************************/
  public function plugin_action_links( $links ) {

    $links[] = '<a href="'. esc_url(get_admin_url(null, 'options-general.php?page='.$this->prefix)) .'">'.__('Settings', 'bbwp-inspired-health-med-td').'</a>';
    return $links;

 }// localization function


 /******************************************/
 /***** Plugin activation function **********/
 /******************************************/
 public function PluginActivation() {

   global $wpdb;
   
   /*$ver = "1.0";
   if(!(isset(self::$options['ver']) && self::$options['ver'] == $ver))
     $this->set_option('ver', $ver);*/

 }// plugin activation


 /******************************************/
 /***** plugin deactivation function **********/
 /******************************************/
 public function PluginDeactivation(){
   
 }// plugin deactivation

 
  /******************************************/
	/***** localization function **********/
	/******************************************/
	public function plugins_loaded(){

		load_plugin_textdomain( 'bbwp-inspired-health-med-td', false, plugin_dir_path(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE) . 'languages/' );

    /*if ( $this->is_compatible() ) {
      add_action( 'elementor/init', [ $this, 'init' ] );
    }*/
    

	}// plugin_loaded

	/******************************************/
  /***** add javascript and css to wp-admin dashboard. **********/
  /******************************************/
  public function wp_admin_style_scripts() {
    if(is_admin()){
      
      //wp_register_script( 'vue3', 'https://unpkg.com/vue@next', array(), '3.2.11', true);
      // wp_register_script( 'vue3', 'https://unpkg.com/vue@3.2.11/dist/vue.global.prod.js', array(), '3.2.11', true);
      // wp_register_script( 'vue3', plugin_dir_url(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE) . 'assets/admin/js/vue-global-3-2-11.js', array(), '3.2.11');

      // $script_abs_path = plugin_dir_path(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE). 'assets/admin/js/script.js';
      // wp_register_script( $this->prefix('script'), plugin_dir_url(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE) . 'assets/admin/js/script.js', array(), get_file_time($script_abs_path));
      // wp_enqueue_script( $this->prefix('script') );
  
      // $js_variables = array('ajax_url' => admin_url('admin-ajax.php'));
      // wp_localize_script(  $this->prefix('script'), $this->prefix, $js_variables );
        
    }else{
      // wp_register_style( $this->prefix('style'), plugin_dir_url(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE) . 'assets/css/style.css', array(), '1.0.0' );
      // wp_enqueue_style($this->prefix('style'));

      
        $script_abs_path = plugin_dir_path(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE). 'assets/frontend/js/script.js';
        wp_register_script( 'wc-pos-app-bbwp', plugin_dir_url(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE) . 'assets/frontend/js/script.js', array('wc-pos-app'), get_file_time($script_abs_path));
        wp_enqueue_script( 'wc-pos-app-bbwp' );
    
        $js_variables = array('ajax_url' => admin_url('admin-ajax.php'));
        wp_localize_script(  'wc-pos-app-bbwp', $this->prefix, $js_variables );
      
      
    }
  }// wp_admin_style_scripts


	/******************************************/
  /***** Intialize the elementor and other plugins extended classes and functions. **********/
  /******************************************/
  public function init() {

	  if ( $this->is_compatible() ) {

      add_action( 'wp_ajax_fetch_cart_session_data', [ $this, 'fetch_cart_session_data'] );
      add_action( 'wp_ajax_nopriv_fetch_cart_session_data', [ $this, 'fetch_cart_session_data'] );
     
		  if(isset($_GET['test']) && $_GET['test'] == 'woo'){
        
		  }
		  
		  
			// Add Plugin actions
      //add_action( 'elementor/widgets/widgets_registered', [ $this, 'init_widgets' ] );
      //add_action( 'elementor/controls/controls_registered', [ $this, 'init_controls' ] );
    
      // Add pattern attribute to form field render
      
      //add_action( 'elementor/element/form/section_form_fields/before_section_end', [ $this, 'addAutocompleteAddressFieldControl' ], 100, 2 );

    }

  }

	private function get_current_cart($email)
        {
            $users = get_users(array('search' => $email));
            $user = array();
            if ($users)
                $user = array_shift($users);
            if (!$user)
                return false;
            return get_user_meta($user->data->ID, '_woocommerce_persistent_cart_1', true);
        }	
	
  public function fetch_cart_session_data(){
    $output = array();

	  $cartData = $this->get_current_cart($_POST['customer_email']);
	  $new_cart_data = [];
	  if(!empty($cartData['cart'])) {
		  foreach($cartData['cart'] as $single_item) {
			  $product_id = $single_item['product_id'];
			  $product = wc_get_product($product_id);
			  $new_cart_data[$product_id] = $single_item;
              $new_cart_data[$product_id]['name'] = $product->get_name();
				$new_cart_data[$product_id]['sku'] = $product->get_sku();
		  }
		  $output['cart_data'][$_POST['customer_email']]['cart'] = $new_cart_data;
	  }
    wp_send_json_success($output);
    die();
  }

} // BBWP_CustomFields class

