<?php
namespace BBWP\InspiredHealthMed\Admin;

// exit if file is called directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class PageSettings extends \BBWP\InspiredHealthMed\Plugin{

  use \BBWP\InspiredHealthMedGeneral\Traits\Singleton;
  use \BBWP\InspiredHealthMedGeneral\Traits\AdminNotices;

  public function __construct(){

    add_action('init', array($this, 'input_handle'));
    add_action( 'admin_menu', array($this,'admin_menu'));

  }// construct function end here

  /******************************************/
  /***** page_bboptions_admin_menu function start from here *********/
  /******************************************/
  public function admin_menu(){
    
    /* add sub menu in our wordpress dashboard main menu */
    //add_menu_page(__('BBWP Inspired Health Med', 'bbwp-inspired-health-med-td'), __('BBWP Inspired Health Med', 'bbwp-inspired-health-med-td'), 'manage_options', $this->prefix, array($this,'add_submenu_page') );
    add_submenu_page('options-general.php', __('BBWP Inspired Health Med', 'bbwp-inspired-health-med-td'), __('BBWP Inspired Health Med', 'bbwp-inspired-health-med-td'), 'manage_options', $this->prefix, array($this,'add_submenu_page') );
    
  }

  /******************************************/
  /***** add_submenu_page_bboptions function start from here *********/
  /******************************************/
  public function add_submenu_page(){ ?>
    <div class="wrap bytebunch_admin_page_container">
      <div id="icon-tools" class="icon32"></div>
      <div id="poststuff">
	      <?php $this->page_tabs(); ?>          
      </div><!-- poststuff-->
    </div><!-- wrap-->
    <?php 
	//$this->bbwp_flipswitch_css();
  }

  /******************************************/
  /***** default_tab_html function start from here *********/
  /******************************************/
  public function default_tab_html(){ ?>
	<div id="postbox-container" class="postbox-container">
		<form action="" method="post">
		<?php wp_nonce_field($this->prefix('nonce'), $this->prefix('nonce')); ?>
		  <div class="meta-box-sortables ui-sortable">
			<div class="postbox" id="<?php echo $this->prefix('vue_app'); ?>">
			  <div class="postbox-header">                    
				<h3 class="hndle ui-sortable-handle"><span><?php _e('BBWP Inspired Health Med Settings', 'bbwp-inspired-health-med-td'); ?></span></h3>
				<div class="handle-actions hide-if-no-js">
				  <button type="button" class="handlediv" aria-expanded="true"><span class="screen-reader-text">Toggle panel: Author</span><span class="toggle-indicator" aria-hidden="true"></span></button>                    
				</div>
			  </div><!-- postbox-header-->
			  <div class="inside">

          <?php
            $fields = \BBWP\InspiredHealthMedGeneral\Fields::instance();
            echo $fields->displaytype['wrapper_open'];
            $selected_values = array();
            foreach($this->get_page_fields() as $field){
              echo $fields->{$field['field_type']}($field, $this->get_option($field['meta_key']));
              // $output = $fields->{$field['field_type']}($field, $this->get_option($field['meta_key']), 'vue');
              // echo $output['html'];
              // $selected_values[$field['meta_key']] = $output['selected'];
            }
            echo $fields->displaytype['wrapper_close'];

            // $repeater_fields = $this->get_repeater_fields();
            // $existing_items = SerializeStringToArray(get_option($this->prefix('repeater_setting')));
            // $repeater = \BBWP\InspiredHealthMedGeneral\FieldsRepeater::instance();
            // $repeater->Display($repeater_fields, $existing_items);
					?>

        <?php 
          // $page_fields = $this->get_page_fields();
          // unset($fields['ver']);
          // unset($fields['selected_metabox']);
          // $metabox = \BBWP\InspiredHealthMedGeneral\MetaBox::instance($this->prefix);
          // $metabox->DisplayOptions($page_fields, $this->prefix('nonce'));
        ?>
          
			  </div><!-- inside-->
			</div><!-- postbox-->
		  </div><!-- meta-box-sortables-->
		  <?php submit_button('Save Changes'); ?>
		</form>
	  </div><!-- postbox-container-->
  <?php
  // $script_abs_path = plugin_dir_path(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE). 'assets/admin/js/vue-app.js';
  // wp_enqueue_script($this->prefix('vue_app'), plugin_dir_url(BBWP_INSPIREDHEALTHMED_PLUGIN_FILE) . 'assets/admin/js/vue-app.js', array('jquery', 'vue3'), get_file_time($script_abs_path));
  // wp_localize_script($this->prefix('vue_app'), $this->prefix('vue_app_svalues'), $selected_values);  
  
  }

  /******************************************/
  /***** page_tabs function start from here *********/
  /******************************************/
  public function page_tabs($is_tabs = false){
    
      $default_tab = null;
      $tab = isset($_GET['tab']) ? $_GET['tab'] : $default_tab;
      
      if($is_tabs){ ?>
        <nav class="nav-tab-wrapper" style="margin-bottom:20px;">
          <a href="?page=<?php echo $this->prefix; ?>" class="nav-tab <?php if($tab===null):?>nav-tab-active<?php endif; ?>"><?php _e('Default Tab', 'bbwp-inspired-health-med-td'); ?></a>
          <a href="?page=<?php echo $this->prefix; ?>&tab=settings" class="nav-tab <?php if($tab==='settings'):?>nav-tab-active<?php endif; ?>"><?php _e('Settings', 'bbwp-inspired-health-med-td'); ?></a>
          <a href="?page=<?php echo $this->prefix; ?>&tab=tools" class="nav-tab <?php if($tab==='tools'):?>nav-tab-active<?php endif; ?>"><?php _e('Tools', 'bbwp-inspired-health-med-td'); ?></a>
        </nav>
      <?php
      }

      if($tab === null || $tab == '')
        $this->default_tab_html();
      elseif($tab == 'settings' && $is_tabs)
        $this->default_tab_html();   
  }

  /******************************************/
  /***** input_handle function start from here *********/
  /******************************************/
  public function input_handle(){
    
    if(!current_user_can('manage_options'))
      return false;

    if(!(isset($_GET['page']) && $_GET['page'] === $this->prefix))
      return false;
      
    if(isset($_POST[$this->prefix('nonce')]) && wp_verify_nonce($_POST[$this->prefix('nonce')], $this->prefix('nonce'))){
      
      $metabox = \BBWP\InspiredHealthMedGeneral\MetaBox::instance();
      $metabox->Set('saveType', \BBWP\InspiredHealthMed\Plugin::instance());
      $metabox->Set('skipSaving', array());
      //$metabox->Set('dataID', $post->ID);
      $metabox->SaveOptions($this->get_page_fields(), 'verified');


      // $repeater_fields = $this->get_repeater_fields();
      // $repeater = \BBWP\InspiredHealthMedGeneral\FieldsRepeater::instance();
      // $repeater->Save($repeater_fields, $this->prefix('repeater_setting'), 'verified');
      
      add_action( 'admin_notices', [ $this, 'admin_notices' ] );
    }


  } // input handle function end here

  /******************************************/
  /***** pageURL function start from here *********/
  /******************************************/
  public function pageURL($param = array()){
    $default_values = array('page' => $this->prefix);
    $param = array_merge($default_values, $param);
    return add_query_arg( $param, admin_url( 'admin.php' ) );
    // return add_query_arg($param, get_admin_url(null, 'admin.php?page='.$this->prefix));
  }

  /******************************************/
  /***** get_page_fields function start from here *********/
  /******************************************/
  public function get_page_fields(){

    return array(
      'enable_email' => array(
        'meta_key' => 'enable_email',
        'field_title' => 'Enable Email System',
        'field_type' => 'flipswitch',
      ),
      'from_email' => array(
        'meta_key' => 'from_email',
        'field_title' => 'Facebook Description',
        'field_type' => 'text',
        'vue_conditions' => array('enable_email' => '1'),
      ),
      'email_message' => array(
        'meta_key' => 'email_message',
        'field_title' => 'Email Message',
        'field_type' => 'textarea',
        'vue_conditions' => array('enable_email' => '1'),
        'field_description' => '<small v-pre>{{var1}}<br />{{var1}}<br />{{var1}}<br />{{var1}}<br />{{var1}}<br /></small>',
        'field_allow_all_code' => 'on',
        'field_disable_autop' => 'on'
      ),
    );

  } // get_page_fields function end here


}// class end here
