<?php
namespace BBWP\InspiredHealthMedGeneral;

if ( ! defined( 'ABSPATH' ) )	exit;

class Countries{

  use \BBWP\InspiredHealthMedGeneral\Traits\Singleton;

  // Generates our secret key
  public static function get_array() {

    return array(
        'AF' => __( 'Afghanistan', 'bbwp_engine_td' ), 
        'AL' => __( 'Albania', 'bbwp_engine_td' ), 
        'DZ' => __( 'Algeria', 'bbwp_engine_td' ), 
        'AS' => __( 'American Samoa', 'bbwp_engine_td' ), 
        'AD' => __( 'Andorra', 'bbwp_engine_td' ), 
        'AO' => __( 'Angola', 'bbwp_engine_td' ), 
        'AI' => __( 'Anguilla', 'bbwp_engine_td' ), 
        'AQ' => __( 'Antarctica', 'bbwp_engine_td' ), 
        'AG' => __( 'Antigua and Barbuda', 'bbwp_engine_td' ), 
        'AR' => __( 'Argentina', 'bbwp_engine_td' ), 
        'AM' => __( 'Armenia', 'bbwp_engine_td' ), 
        'AW' => __( 'Aruba', 'bbwp_engine_td' ), 
        'AU' => __( 'Australia', 'bbwp_engine_td' ), 
        'AT' => __( 'Austria', 'bbwp_engine_td' ), 
        'AZ' => __( 'Azerbaijan', 'bbwp_engine_td' ), 
        'BS' => __( 'Bahamas', 'bbwp_engine_td' ), 
        'BH' => __( 'Bahrain', 'bbwp_engine_td' ), 
        'BD' => __( 'Bangladesh', 'bbwp_engine_td' ), 
        'BB' => __( 'Barbados', 'bbwp_engine_td' ), 
        'BY' => __( 'Belarus', 'bbwp_engine_td' ), 
        'BE' => __( 'Belgium', 'bbwp_engine_td' ), 
        'BZ' => __( 'Belize', 'bbwp_engine_td' ), 
        'BJ' => __( 'Benin', 'bbwp_engine_td' ), 
        'BM' => __( 'Bermuda', 'bbwp_engine_td' ), 
        'BT' => __( 'Bhutan', 'bbwp_engine_td' ), 
        'BO' => __( 'Bolivia', 'bbwp_engine_td' ), 
        'BA' => __( 'Bosnia and Herzegovina', 'bbwp_engine_td' ), 
        'BW' => __( 'Botswana', 'bbwp_engine_td' ), 
        'BV' => __( 'Bouvet Island', 'bbwp_engine_td' ), 
        'BR' => __( 'Brazil', 'bbwp_engine_td' ), 
        'BQ' => __( 'British Antarctic Territory', 'bbwp_engine_td' ), 
        'IO' => __( 'British Indian Ocean Territory', 'bbwp_engine_td' ), 
        'VG' => __( 'British Virgin Islands', 'bbwp_engine_td' ), 
        'BN' => __( 'Brunei', 'bbwp_engine_td' ), 
        'BG' => __( 'Bulgaria', 'bbwp_engine_td' ), 
        'BF' => __( 'Burkina Faso', 'bbwp_engine_td' ), 
        'BI' => __( 'Burundi', 'bbwp_engine_td' ), 
        'KH' => __( 'Cambodia', 'bbwp_engine_td' ), 
        'CM' => __( 'Cameroon', 'bbwp_engine_td' ), 
        'CA' => __( 'Canada', 'bbwp_engine_td' ), 
        'CT' => __( 'Canton and Enderbury Islands', 'bbwp_engine_td' ), 
        'CV' => __( 'Cape Verde', 'bbwp_engine_td' ), 
        'KY' => __( 'Cayman Islands', 'bbwp_engine_td' ), 
        'CF' => __( 'Central African Republic', 'bbwp_engine_td' ), 
        'TD' => __( 'Chad', 'bbwp_engine_td' ), 
        'CL' => __( 'Chile', 'bbwp_engine_td' ), 
        'CN' => __( 'China', 'bbwp_engine_td' ), 
        'CX' => __( 'Christmas Island', 'bbwp_engine_td' ), 
        'CC' => __( 'Cocos [Keeling] Islands', 'bbwp_engine_td' ), 
        'CO' => __( 'Colombia', 'bbwp_engine_td' ), 
        'KM' => __( 'Comoros', 'bbwp_engine_td' ), 
        'CG' => __( 'Congo - Brazzaville', 'bbwp_engine_td' ), 
        'CD' => __( 'Congo - Kinshasa', 'bbwp_engine_td' ), 
        'CK' => __( 'Cook Islands', 'bbwp_engine_td' ), 
        'CR' => __( 'Costa Rica', 'bbwp_engine_td' ), 
        'HR' => __( 'Croatia', 'bbwp_engine_td' ), 
        'CU' => __( 'Cuba', 'bbwp_engine_td' ), 
        'CY' => __( 'Cyprus', 'bbwp_engine_td' ), 
        'CZ' => __( 'Czech Republic', 'bbwp_engine_td' ), 
        'CI' => __( 'Cote dIvoire', 'bbwp_engine_td' ), 
        'DK' => __( 'Denmark', 'bbwp_engine_td' ), 
        'DJ' => __( 'Djibouti', 'bbwp_engine_td' ), 
        'DM' => __( 'Dominica', 'bbwp_engine_td' ), 
        'DO' => __( 'Dominican Republic', 'bbwp_engine_td' ), 
        'NQ' => __( 'Dronning Maud Land', 'bbwp_engine_td' ), 
        'DD' => __( 'East Germany', 'bbwp_engine_td' ), 
        'EC' => __( 'Ecuador', 'bbwp_engine_td' ), 
        'EG' => __( 'Egypt', 'bbwp_engine_td' ), 
        'SV' => __( 'El Salvador', 'bbwp_engine_td' ), 
        'GQ' => __( 'Equatorial Guinea', 'bbwp_engine_td' ), 
        'ER' => __( 'Eritrea', 'bbwp_engine_td' ), 
        'EE' => __( 'Estonia', 'bbwp_engine_td' ), 
        'ET' => __( 'Ethiopia', 'bbwp_engine_td' ), 
        'FK' => __( 'Falkland Islands', 'bbwp_engine_td' ), 
        'FO' => __( 'Faroe Islands', 'bbwp_engine_td' ), 
        'FJ' => __( 'Fiji', 'bbwp_engine_td' ), 
        'FI' => __( 'Finland', 'bbwp_engine_td' ), 
        'FR' => __( 'France', 'bbwp_engine_td' ), 
        'GF' => __( 'French Guiana', 'bbwp_engine_td' ), 
        'PF' => __( 'French Polynesia', 'bbwp_engine_td' ), 
        'TF' => __( 'French Southern Territories', 'bbwp_engine_td' ), 
        'FQ' => __( 'French Southern and Antarctic Territories', 'bbwp_engine_td' ), 
        'GA' => __( 'Gabon', 'bbwp_engine_td' ), 
        'GM' => __( 'Gambia', 'bbwp_engine_td' ), 
        'GE' => __( 'Georgia', 'bbwp_engine_td' ), 
        'DE' => __( 'Germany', 'bbwp_engine_td' ), 
        'GH' => __( 'Ghana', 'bbwp_engine_td' ), 
        'GI' => __( 'Gibraltar', 'bbwp_engine_td' ), 
        'GR' => __( 'Greece', 'bbwp_engine_td' ), 
        'GL' => __( 'Greenland', 'bbwp_engine_td' ), 
        'GD' => __( 'Grenada', 'bbwp_engine_td' ), 
        'GP' => __( 'Guadeloupe', 'bbwp_engine_td' ), 
        'GU' => __( 'Guam', 'bbwp_engine_td' ), 
        'GT' => __( 'Guatemala', 'bbwp_engine_td' ), 
        'GG' => __( 'Guernsey', 'bbwp_engine_td' ), 
        'GN' => __( 'Guinea', 'bbwp_engine_td' ), 
        'GW' => __( 'Guinea-Bissau', 'bbwp_engine_td' ), 
        'GY' => __( 'Guyana', 'bbwp_engine_td' ), 
        'HT' => __( 'Haiti', 'bbwp_engine_td' ), 
        'HM' => __( 'Heard Island and McDonald Islands', 'bbwp_engine_td' ), 
        'HN' => __( 'Honduras', 'bbwp_engine_td' ), 
        'HK' => __( 'Hong Kong SAR China', 'bbwp_engine_td' ), 
        'HU' => __( 'Hungary', 'bbwp_engine_td' ), 
        'IS' => __( 'Iceland', 'bbwp_engine_td' ), 
        'IN' => __( 'India', 'bbwp_engine_td' ), 
        'ID' => __( 'Indonesia', 'bbwp_engine_td' ), 
        'IR' => __( 'Iran', 'bbwp_engine_td' ), 
        'IQ' => __( 'Iraq', 'bbwp_engine_td' ), 
        'IE' => __( 'Ireland', 'bbwp_engine_td' ), 
        'IM' => __( 'Isle of Man', 'bbwp_engine_td' ), 
        'IL' => __( 'Israel', 'bbwp_engine_td' ), 
        'IT' => __( 'Italy', 'bbwp_engine_td' ), 
        'JM' => __( 'Jamaica', 'bbwp_engine_td' ), 
        'JP' => __( 'Japan', 'bbwp_engine_td' ), 
        'JE' => __( 'Jersey', 'bbwp_engine_td' ), 
        'JT' => __( 'Johnston Island', 'bbwp_engine_td' ), 
        'JO' => __( 'Jordan', 'bbwp_engine_td' ), 
        'KZ' => __( 'Kazakhstan', 'bbwp_engine_td' ), 
        'KE' => __( 'Kenya', 'bbwp_engine_td' ), 
        'KI' => __( 'Kiribati', 'bbwp_engine_td' ), 
        'KW' => __( 'Kuwait', 'bbwp_engine_td' ), 
        'KG' => __( 'Kyrgyzstan', 'bbwp_engine_td' ), 
        'LA' => __( 'Laos', 'bbwp_engine_td' ), 
        'LV' => __( 'Latvia', 'bbwp_engine_td' ), 
        'LB' => __( 'Lebanon', 'bbwp_engine_td' ), 
        'LS' => __( 'Lesotho', 'bbwp_engine_td' ), 
        'LR' => __( 'Liberia', 'bbwp_engine_td' ), 
        'LY' => __( 'Libya', 'bbwp_engine_td' ), 
        'LI' => __( 'Liechtenstein', 'bbwp_engine_td' ), 
        'LT' => __( 'Lithuania', 'bbwp_engine_td' ), 
        'LU' => __( 'Luxembourg', 'bbwp_engine_td' ), 
        'MO' => __( 'Macau SAR China', 'bbwp_engine_td' ), 
        'MK' => __( 'Macedonia', 'bbwp_engine_td' ), 
        'MG' => __( 'Madagascar', 'bbwp_engine_td' ), 
        'MW' => __( 'Malawi', 'bbwp_engine_td' ), 
        'MY' => __( 'Malaysia', 'bbwp_engine_td' ), 
        'MV' => __( 'Maldives', 'bbwp_engine_td' ), 
        'ML' => __( 'Mali', 'bbwp_engine_td' ), 
        'MT' => __( 'Malta', 'bbwp_engine_td' ), 
        'MH' => __( 'Marshall Islands', 'bbwp_engine_td' ), 
        'MQ' => __( 'Martinique', 'bbwp_engine_td' ), 
        'MR' => __( 'Mauritania', 'bbwp_engine_td' ), 
        'MU' => __( 'Mauritius', 'bbwp_engine_td' ), 
        'YT' => __( 'Mayotte', 'bbwp_engine_td' ), 
        'FX' => __( 'Metropolitan France', 'bbwp_engine_td' ), 
        'MX' => __( 'Mexico', 'bbwp_engine_td' ), 
        'FM' => __( 'Micronesia', 'bbwp_engine_td' ), 
        'MI' => __( 'Midway Islands', 'bbwp_engine_td' ), 
        'MD' => __( 'Moldova', 'bbwp_engine_td' ), 
        'MC' => __( 'Monaco', 'bbwp_engine_td' ), 
        'MN' => __( 'Mongolia', 'bbwp_engine_td' ), 
        'ME' => __( 'Montenegro', 'bbwp_engine_td' ), 
        'MS' => __( 'Montserrat', 'bbwp_engine_td' ), 
        'MA' => __( 'Morocco', 'bbwp_engine_td' ), 
        'MZ' => __( 'Mozambique', 'bbwp_engine_td' ), 
        'MM' => __( 'Myanmar [Burma]', 'bbwp_engine_td' ), 
        'NA' => __( 'Namibia', 'bbwp_engine_td' ), 
        'NR' => __( 'Nauru', 'bbwp_engine_td' ), 
        'NP' => __( 'Nepal', 'bbwp_engine_td' ), 
        'NL' => __( 'Netherlands', 'bbwp_engine_td' ), 
        'AN' => __( 'Netherlands Antilles', 'bbwp_engine_td' ), 
        'NT' => __( 'Neutral Zone', 'bbwp_engine_td' ), 
        'NC' => __( 'New Caledonia', 'bbwp_engine_td' ), 
        'NZ' => __( 'New Zealand', 'bbwp_engine_td' ), 
        'NI' => __( 'Nicaragua', 'bbwp_engine_td' ), 
        'NE' => __( 'Niger', 'bbwp_engine_td' ), 
        'NG' => __( 'Nigeria', 'bbwp_engine_td' ), 
        'NU' => __( 'Niue', 'bbwp_engine_td' ), 
        'NF' => __( 'Norfolk Island', 'bbwp_engine_td' ), 
        'KP' => __( 'North Korea', 'bbwp_engine_td' ), 
        'VD' => __( 'North Vietnam', 'bbwp_engine_td' ), 
        'MP' => __( 'Northern Mariana Islands', 'bbwp_engine_td' ), 
        'NO' => __( 'Norway', 'bbwp_engine_td' ), 
        'OM' => __( 'Oman', 'bbwp_engine_td' ), 
        'PC' => __( 'Pacific Islands Trust Territory', 'bbwp_engine_td' ), 
        'PK' => __( 'Pakistan', 'bbwp_engine_td' ), 
        'PW' => __( 'Palau', 'bbwp_engine_td' ), 
        'PS' => __( 'Palestinian Territories', 'bbwp_engine_td' ), 
        'PA' => __( 'Panama', 'bbwp_engine_td' ), 
        'PZ' => __( 'Panama Canal Zone', 'bbwp_engine_td' ), 
        'PG' => __( 'Papua New Guinea', 'bbwp_engine_td' ), 
        'PY' => __( 'Paraguay', 'bbwp_engine_td' ), 
        'YD' => __( 'People\'s Democratic Republic of Yemen', 'bbwp_engine_td' ), 
        'PE' => __( 'Peru', 'bbwp_engine_td' ), 
        'PH' => __( 'Philippines', 'bbwp_engine_td' ), 
        'PN' => __( 'Pitcairn Islands', 'bbwp_engine_td' ), 
        'PL' => __( 'Poland', 'bbwp_engine_td' ), 
        'PT' => __( 'Portugal', 'bbwp_engine_td' ), 
        'PR' => __( 'Puerto Rico', 'bbwp_engine_td' ), 
        'QA' => __( 'Qatar', 'bbwp_engine_td' ), 
        'RO' => __( 'Romania', 'bbwp_engine_td' ), 
        'RU' => __( 'Russia', 'bbwp_engine_td' ), 
        'RW' => __( 'Rwanda', 'bbwp_engine_td' ), 
        'BL' => __( 'Saint Barthélemy', 'bbwp_engine_td' ), 
        'SH' => __( 'Saint Helena', 'bbwp_engine_td' ), 
        'KN' => __( 'Saint Kitts and Nevis', 'bbwp_engine_td' ), 
        'LC' => __( 'Saint Lucia', 'bbwp_engine_td' ), 
        'MF' => __( 'Saint Martin', 'bbwp_engine_td' ), 
        'PM' => __( 'Saint Pierre and Miquelon', 'bbwp_engine_td' ), 
        'VC' => __( 'Saint Vincent and the Grenadines', 'bbwp_engine_td' ), 
        'WS' => __( 'Samoa', 'bbwp_engine_td' ), 
        'SM' => __( 'San Marino', 'bbwp_engine_td' ), 
        'SA' => __( 'Saudi Arabia', 'bbwp_engine_td' ), 
        'SN' => __( 'Senegal', 'bbwp_engine_td' ), 
        'RS' => __( 'Serbia', 'bbwp_engine_td' ), 
        'CS' => __( 'Serbia and Montenegro', 'bbwp_engine_td' ), 
        'SC' => __( 'Seychelles', 'bbwp_engine_td' ), 
        'SL' => __( 'Sierra Leone', 'bbwp_engine_td' ), 
        'SG' => __( 'Singapore', 'bbwp_engine_td' ), 
        'SK' => __( 'Slovakia', 'bbwp_engine_td' ), 
        'SI' => __( 'Slovenia', 'bbwp_engine_td' ), 
        'SB' => __( 'Solomon Islands', 'bbwp_engine_td' ), 
        'SO' => __( 'Somalia', 'bbwp_engine_td' ), 
        'ZA' => __( 'South Africa', 'bbwp_engine_td' ), 
        'GS' => __( 'South Georgia and the South Sandwich Islands', 'bbwp_engine_td' ), 
        'KR' => __( 'South Korea', 'bbwp_engine_td' ), 
        'ES' => __( 'Spain', 'bbwp_engine_td' ), 
        'LK' => __( 'Sri Lanka', 'bbwp_engine_td' ), 
        'SD' => __( 'Sudan', 'bbwp_engine_td' ), 
        'SR' => __( 'Suriname', 'bbwp_engine_td' ), 
        'SJ' => __( 'Svalbard and Jan Mayen', 'bbwp_engine_td' ), 
        'SZ' => __( 'Swaziland', 'bbwp_engine_td' ), 
        'SE' => __( 'Sweden', 'bbwp_engine_td' ), 
        'CH' => __( 'Switzerland', 'bbwp_engine_td' ), 
        'SY' => __( 'Syria', 'bbwp_engine_td' ), 
        'ST' => __( 'São Tomé and Príncipe', 'bbwp_engine_td' ), 
        'TW' => __( 'Taiwan', 'bbwp_engine_td' ), 
        'TJ' => __( 'Tajikistan', 'bbwp_engine_td' ), 
        'TZ' => __( 'Tanzania', 'bbwp_engine_td' ), 
        'TH' => __( 'Thailand', 'bbwp_engine_td' ), 
        'TL' => __( 'Timor-Leste', 'bbwp_engine_td' ), 
        'TG' => __( 'Togo', 'bbwp_engine_td' ), 
        'TK' => __( 'Tokelau', 'bbwp_engine_td' ), 
        'TO' => __( 'Tonga', 'bbwp_engine_td' ), 
        'TT' => __( 'Trinidad and Tobago', 'bbwp_engine_td' ), 
        'TN' => __( 'Tunisia', 'bbwp_engine_td' ), 
        'TR' => __( 'Turkey', 'bbwp_engine_td' ), 
        'TM' => __( 'Turkmenistan', 'bbwp_engine_td' ), 
        'TC' => __( 'Turks and Caicos Islands', 'bbwp_engine_td' ), 
        'TV' => __( 'Tuvalu', 'bbwp_engine_td' ), 
        'UM' => __( 'U.S. Minor Outlying Islands', 'bbwp_engine_td' ), 
        'PU' => __( 'U.S. Miscellaneous Pacific Islands', 'bbwp_engine_td' ), 
        'VI' => __( 'U.S. Virgin Islands', 'bbwp_engine_td' ), 
        'UG' => __( 'Uganda', 'bbwp_engine_td' ), 
        'UA' => __( 'Ukraine', 'bbwp_engine_td' ), 
        'SU' => __( 'Union of Soviet Socialist Republics', 'bbwp_engine_td' ), 
        'AE' => __( 'United Arab Emirates', 'bbwp_engine_td' ), 
        'GB' => __( 'United Kingdom', 'bbwp_engine_td' ), 
        'US' => __( 'United States', 'bbwp_engine_td' ), 
        'ZZ' => __( 'Unknown or Invalid Region', 'bbwp_engine_td' ), 
        'UY' => __( 'Uruguay', 'bbwp_engine_td' ), 
        'UZ' => __( 'Uzbekistan', 'bbwp_engine_td' ), 
        'VU' => __( 'Vanuatu', 'bbwp_engine_td' ), 
        'VA' => __( 'Vatican City', 'bbwp_engine_td' ), 
        'VE' => __( 'Venezuela', 'bbwp_engine_td' ), 
        'VN' => __( 'Vietnam', 'bbwp_engine_td' ), 
        'WK' => __( 'Wake Island', 'bbwp_engine_td' ), 
        'WF' => __( 'Wallis and Futuna', 'bbwp_engine_td' ), 
        'EH' => __( 'Western Sahara', 'bbwp_engine_td' ), 
        'YE' => __( 'Yemen', 'bbwp_engine_td' ), 
        'ZM' => __( 'Zambia', 'bbwp_engine_td' ), 
        'ZW' => __( 'Zimbabwe', 'bbwp_engine_td' ), 
        'AX' => __( 'Aland Islands', 'bbwp_engine_td' ), 
    );
  }
}